' *********************************************************************
' Funktion:	Schreibt Dateinamen aus gedropptem bzw. ausgewhltem Ordner
'		und deren Unterordner in eine neue Excel-Tabelle
'
' Erfordert:	- Windows Scripting Host 2.0
'				- Excel ab Version 97
'
' Vorgehen:	- Vorliegenden Text als vbs-Datei abspeichern 
'		  z.B. unter dem Namen 'Dir_in_XLS.vbs.
'		- Diese Datei auf dem Desktop ablegen oder 
'		  dort eine Verknpfung erstellen.
'
' Anwendung: Anzuzeigenden Ordner auf die Datei bzw.
'		  auf die Verknpfung ziehen oder
'		  nach Doppelklick anzuzeigenden Ordner
'		  auswhlen und mit OK besttigen
' *********************************************************************
'Version 4.3 - ab WINDOWS 7 wird 
'				bei Musikstcken Merkmal 'Dauer: ' durch 'Lmge: ' ersetzt - 18.07.2013
'				bei JPG-Bildern Merkmal 'Bild aufgenommen am: ' durch 'Aufnahmedatum: ' ersetzt - 18.07.2013
'Version 4.2 - Benutzung der Merkmale .Y und :YP auch fr WMA-Dateien - 30.03.2008
'Version 4.1 - Erweitert um das Merkmal :YP fr puristische Ausgabe von MP3-Dateien - 27.02.2008
'Version 4.0 - Erweitert um das Merkmal :Y fr MP3-Dateien (Spieldauer)  - 26.02.2008
'Version 3.3 - Bug bei Exif-Daten bereinigt / erw. um Abmessungen - 20.08.2007
'Version 3.2 - Datumanzeige erweitert um Sekundenanzeige - 10.07.2007
'Version 3.1 - Fehlerbereinigung bei Exif-Abfrage - 21.05.2007
'Version 3.0 - Erweitert um Exif-Abfrage mit Parameter :X - 17.05.2007
'Version 2.5 - Datumsformat erzwungen (TT.MM.JJJJ  hh:mm) - 13.05.2007
'Version 2.4 - Vorgabe fr Auswahl ber Registry - 07.05.2007
'Version 2.3 - Strukturtiefe kann bestimmt werden
'Version 2.2 - Auswahl nur Ordner oder Ordner mit Dateien
'Version 2.1 - Weitergabe an Excel ber ein Array (schneller)
'Version 2.0 - Dateianzeige ber alle Unterordner
' Copyright (C) 2007 Harald Maeckler, Dsseldorf
' *********************************************************************
'**Start Encode**
Option Explicit

'Definitionen
Dim AppShell, BrowseDir, Verz
Dim objFS, objFolder, objSubFolder, myfolder, tiefe
Dim Anzahl, Groesse, FileAnzahl, SubAnzahl, Gesamtanzahl
Dim Pos, Pfad
Dim Tabelle(), Dimension
Dim msg1, msg2, Eingabe, BisTiefe
Dim ObjFile, strExt, SubZeile, Kursivzeilen, KursivListe, Element
Dim Filter, msg, objshell, key, Vorgabe, AendDatum
Dim objExcel, Zeile, ZeilenNr
Dim Exif, MP3, Pur, Vorwahl, objOrdner, objOrdnerItem, Dateipfad, Dateiname, DateiBez
Dim Wert, Abmessung, BildDatum, Kamera, Typ, GroesseD, Dauer
Dim PosEnde, PosA, PosB, PosK,VLaenge
Dim X, Y, PixelG

'************************************* Auswahlmerkmale*****************************************************************
msg1 = "Eintragung von Unterordnern und Dateien in" & vbNewLine & "eine Excel-Tabelle ab gewhltem Ordner:" & vbNewLine
msg2 = vbNewLine & vbNewLine & "Auswahlmerkmale:" & vbNewLine & _
	" S  = Ordnerstruktur ohne Dateien" & vbNewLine & _
	" D  = Ordnerstruktur mit Dateien" & vbNewLine & vbNewLine & _
	" Mit einer zustzlichen Ziffernangabe von 0 bis 9" & vbNewLine & _
	" kann die Strukturtiefe begrenzt werden." & vbNewLine & vbNewLine & _
	"Beispiele:" & vbNewLine & _
	"S1 = Ordnerstruktur bis zur 1. Ebene" & vbNewLine & _
	"D0 = nur gewhlter Ordner mit Dateien" & vbNewLine & _
	"D3 = Ordner bis zur 3. Ebene mit Dateien" & vbNewLine & vbNewLine & _
	"Filtern nach Dateierweiterung mglich:"  & vbNewLine & _
	"Beispiel: D0.JPG.BMP" & vbNewLine  & vbNewLine &  _
	"Wird am Ende eingegeben" & vbNewLine & _
	" :X  werden bei Bilddateien" & vbNewLine & _
	"      Kameratyp und Aufnahmedatum ausgelesen" & vbNewLine & _
	"      Merkmalsbeispiel: D.JPG:X" & vbNewLine & _
	" :Y  wird bei MP3-und WMA-Dateien" & vbNewLine & _
	"      die Spieldauer ausgelesen" & vbNewLine & _
	"      Merkmalsbeispiel: D.MP3:Y" & vbNewLine & _
	"      Sonderfall: D.MP3:YP = puristische Ausgabe" & vbNewLine & vbNewLine & _
	"Merkmal eingeben" & vbNewLine & "und mit RETURN besttigen!" & vbNewLine & _
	"(Gro- und Kleinschreibung zulssig!)"

'****************************** Prfung ob Ordner ok und Excel vorhanden *********** **************************************
On Error Resume Next

Set objFS = WScript.CreateObject("Scripting.FileSystemObject")		'FileSytemObject
Set AppShell = CreateObject("Shell.Application")					'Explorer-Aufruf

Set objFolder = objFS.GetFolder(WScript.Arguments(0))				'gedroppter Ordner
	If objFolder Is Nothing Then
		Set BrowseDir = AppShell.BrowseForFolder(0, "", &H1, 17)
		Verz = BrowseDir.ParentFolder.ParseName(BrowseDir.Title).Path

		If Err.Number > 0 Then
			Pos = InStr(BrowseDir, ":")
			Verz = Mid(BrowseDir, Pos - 1, 1) & ":\"
		End If

		Set objFolder =  objFS.GetFolder(Verz)
	End If

	If objFolder Is Nothing Then									'kein Ordner bekannt 
		MsgBox "Kein Ordner ausgewhlt", vbInformation, Wscript.ScriptName
		WScript.Quit
	End if

Set objExcel = WScript.CreateObject("Excel.Application")			'Excel-Aufruf
	If objExcel Is Nothing then
		MsgBox "Excel kann nicht gestartet werden.", vbInformation, Wscript.ScriptName
		WScript.Quit
	End If

'*********************************************** Hauptteil **********************************************************
'Abfrage der Vorgabe in der Registry 
set objshell = CreateObject("WScript.Shell")
Const SCHLUESSEL = "HKCU\Software\eturah\Dir_in_XLS"
Const EINTRAG = "Merkmal"
key = SCHLUESSEL & "\" & EINTRAG

If KeyExists(key) Then
   Vorgabe = objshell.RegRead(key)	'Auslesen der Vorgabe aus der Registry
Else
   Vorgabe = "D"
End If

' Auswahl und Eintrag der Vorgabe in die Registry
Groesse = FormatNumber(objFolder.size / 1024^2,2) & " MB"
call Auswahl()
objshell.RegWrite key, Vorgabe, "REG_SZ"

'Excelblatt aufrufen und Eintrag der Kopfzeilen
With objExcel
	.Workbooks.Add
	.Visible = True

'Definitionen (ggf. Eintrag des Filters und/oder Exif-Abfrage)
Zeile = 4 'Tabellenlistenbeginn	
if len(Filter) > 0 and Not Pur then
	Zeile = Zeile + 1
	.ActiveSheet.Cells(Zeile - 2,1).Value = "- Dateien gefiltert nach Erweiterung " & Filter
end if
if Exif and Not Pur then
	Zeile = Zeile + 1
	.ActiveSheet.Cells(Zeile - 2,1).Value = "- Bei Bilddateien werden diverse Exif-Daten ausgelesen, soweit vorhanden"
end if
if MP3 and Not Pur then
	Zeile = Zeile + 1
	.ActiveSheet.Cells(Zeile - 2,1).Value = "- Bei MP3-Dateien wird die Zeitdauer ausgelesen"
end if

'Bitte warten! eintragen
	.ActiveSheet.Cells(Zeile,3).Value = "Bitte warten!"
	.Range("C" + cstr(Zeile)).Select
    With .Selection.Font
        .Name = "Arial"
        .Size = 18
    End With
    .Range("A1").Select

'Unterordner zhlen und Anzeige der Kopfzeile
call ZaehlerSub(objFolder, 0)
	SubAnzahl = SubAnzahl - 1
	.ActiveSheet.Cells(1,1).Value = objFolder.Path
	.ActiveSheet.Cells(2,1).Value = Groesse & " gesamt / bis " & " Ordnertiefe " & BisTiefe & " -> " & SubAnzahl & _
		" Unterordner mit " & FormatNumber(FileAnzahl,0) & " Dateien"

if left(Eingabe,1) = "S" then
	Gesamtanzahl = SubAnzahl
	Dimension = 1
	Redim Tabelle(Gesamtanzahl,Dimension)
	Dimension = 0
else
	Gesamtanzahl = SubAnzahl + FileAnzahl + 1
	Dimension = 9
	Redim Tabelle(Gesamtanzahl,Dimension)
	Dimension = 1
'Eintrag der Spaltenberschriften bei Dateiabfrage
	Tabelle(0,0) = "ON" : Tabelle(0,1) = "Datei-Name" : Tabelle(0,3) = "Ext."
	Tabelle(0,4) = "Byte" : Tabelle(0,5) = "nderungs-Datum"
	if Exif then Tabelle(0,6) = "Kamera" : Tabelle(0,7) = "Aufnahme-Datum" : Tabelle(0,8) = "B x H [px]"
	if MP3 then Tabelle(0,6) = "Dauer"
end if

'Array fllen
	FileAnzahl = 0
call ShowSubfolder(objFolder, 0)

'Bitte warten! lschen
    .Range("C" + cstr(Zeile)).Select
    .Selection.ClearContents
    With .Selection.Font
        .Name = "Arial"
        .Size = 10
    End With
    .Range("A1").Select

'Array in Excelblatt eintrage
	.ActiveSheet.Cells(Zeile,2).Resize(Ubound(Tabelle,1)+1,Ubound(Tabelle,2)+1).Value = Tabelle
	set Tabelle = nothing

end with 'Excelblatt schlieen

'Formatierung aufrufen

if Pur then call Bereinigung else call Formatierung

'*********************************************** Ende des Hauptteils ****************************************************

'*********************************************** SUB-Routinen *********************************************************

Sub Auswahl
'Benutzerauswahl
do
	Eingabe = ucase(InputBox(msg1 & objFolder & msg2, "Auswahl", Vorgabe))
	if Eingabe = "" then WScript.Quit
	
	'Exif soll abgefragt werden?
	Pos = instr(Eingabe,":X")
	if Pos > 0 then
		Exif = True
		Vorwahl = ":X"
		Eingabe = left(Eingabe, Pos-1)
	end if
	
	'Dauer bei MP3  soll abgefragt werden?
	Pur = False
	if instr(Eingabe,":YP") > 0 then 'p steht fr Pur (Ausgabe ohne Vorzeilen, Extension und Datum)
		MP3 = True
		Pur = True
		Vorwahl = ":YP"
		Eingabe = left(Eingabe, instr(Eingabe,":YP")-1)
	elseif instr(Eingabe,":Y") > 0 then
		MP3 = True
		Vorwahl = ":Y"
		Eingabe = left(Eingabe, instr(Eingabe,":Y")-1)
	end if
	
	'Dateifilter ermitteln
	Pos = instr(Eingabe,".")
	if Pos > 0 then 
		Filter = mid(Eingabe, Pos)
		Eingabe = left(Eingabe, Pos-1)
	end if
	
	'Test, ob Auswahl ok und Ordnertiefe bestimmen
	if left(Eingabe,2) = "S0" then
		msgbox "S0 ist nicht sinnvoll. Es wrde nur der gewhlte Ordner angezeigt."
	elseif left(Eingabe,1) = "S" and Exif then
		Exif = False
		msgbox "Falsche Eingabe. Exif-Abfrage nur sinnvoll bei Dateien!"
	elseif left(Eingabe,1) = "S" and len(Filter) > 0 then
		Filter = ""
		msgbox "Falsche Eingabe. Filtervorgabe nur sinnvoll bei Dateien!"
	elseif len(Eingabe) = 1 and (Eingabe = "D" or Eingabe = "S") then
		BisTiefe = 99
		Vorgabe = Eingabe & Filter & Vorwahl
		exit do
	elseif len(Eingabe) = 2 and (left(Eingabe,1) = "D" or left(Eingabe,1) = "S") and _
		(right(Eingabe,1) = "0" or right(Eingabe,1) = "1" or right(Eingabe,1) = "2" or _
		 right(Eingabe,1) = "3" or right(Eingabe,1) = "4" or right(Eingabe,1) = "5" or _
		 right(Eingabe,1) = "6" or right(Eingabe,1) = "7" or _
		 right(Eingabe,1) = "8" or right(Eingabe,1) = "9") then 
			BisTiefe = cint(right(Eingabe,1))
			Vorgabe = Eingabe & Filter & Vorwahl
			exit do
	else
		msgbox "Falsche Eingabe, bitte erneut versuchen!"
	end if
loop
End Sub
'*********************************************************************************************************************
Function KeyExists(ByVal key)
'Prfen ob Registry-Eintrag vorhanden
   On Error Resume Next
   objshell.RegRead key
   KeyExists = (Err.number=0)
   On Error Goto 0
End Function
'*********************************************************************************************************************
Sub ZaehlerSub(ByVal myfolder, ByVal tiefe)
'Zhlen der Ordner und Unterordner
	if tiefe <= BisTiefe then
		SubAnzahl = SubAnzahl + 1						'Anzahl Unteordner
		FileAnzahl = FileAnzahl + myfolder.files.count	'Anzahl Dateien
	end if
	For Each objsubfolder In myfolder.subfolders
      ZaehlerSub objsubfolder, tiefe + 1
	Next
end sub
'*********************************************************************************************************************
Sub ShowSubfolder(ByVal myfolder,ByVal tiefe)
'Eintrag der Ordnernamen in das Array
if tiefe <= BisTiefe then	
	Pfad = myfolder.name					'wenn kompletter Pfad gewnscht, .name durch .path ersetzen
	Anzahl = myfolder.files.count
	FileAnzahl = FileAnzahl + Anzahl
		msg = string(tiefe,">") & "  " & Pfad
		if Pur then
			Tabelle(Dimension,0) =  LTrim(msg)
		else
			Tabelle(Dimension,0) =  LTrim(msg) & " - " & Anzahl & " Dateien"
		end if
		Dimension = Dimension + 1
	if left(Eingabe,1) = "D" then call DateiAuflistung(myfolder)
end if

	For Each objsubfolder In myfolder.subfolders
		ShowSubfolder objsubfolder, tiefe + 1
	Next
End Sub
'*********************************************************************************************************************
Sub DateiAuflistung(ByVal myfolder)
'Eintrag der Dateinamen mit einigen Zustzen in das Array
Groesse = 0
SubZeile = Dimension

'Vorberetung zur Ermittlung von EXif-Daten
Set objOrdner = AppShell.NameSpace(cstr(myfolder))

'Ermittlung aller Dateien  des Ordners
For Each objFile In myfolder.Files					'Dateien-Auflistung
	strExt = Ucase(objFS.GetExtensionName(objFile.Name))

	if len(Filter) = 0 or instr(Filter, strExt) > 0 then
		if Pur then
			Pos = InstrRev(objFile.Name,".")
			DateiBez = left(objFile.Name,Pos-1)
		else
			DateiBez = objFile.Name
		end if
		Tabelle(Dimension,1) = DateiBez
		Tabelle(Dimension,2) = " "
		Tabelle(Dimension,3) = strExt
		Tabelle(Dimension,4) = objFile.Size
			AendDatum = objFile.DateLastModified	'(gendert) oder DateCreated (erzeugt)
													'oder DateLastAccessed (zugegriffen)
			If IsDate(AendDatum) then
				AendDatum = FormatDateTime(AendDatum, 2) & " " & FormatDateTime(AendDatum, 4)
			end if
		Tabelle(Dimension,5) = AendDatum
			if Exif and strExt = "JPG" or strExt = "JPEG" then
				call ExifDaten (objFile.Name)
			elseif MP3 and strExt = "MP3" or strExt = "WMA" then
				call MP3Daten (objFile.Name)
			end if
		Groesse = Groesse + objFile.Size
		Dimension = Dimension + 1
	end if
Next

if Groesse < 1024 then
	Groesse = Groesse & " Byte"
elseif Groesse < 1024^2 then
	Groesse = FormatNumber(Groesse / 1024,2) & " kB"
else
	Groesse = FormatNumber(Groesse / 1024^2,2) & " MB"
end if

if len(Filter) = 0 then
	if not Pur then
	Tabelle(SubZeile-1,0) = Tabelle(SubZeile-1,0) & " / " & Groesse
	end if
else
	if not Pur then
	Tabelle(SubZeile-1,0) = Tabelle(SubZeile-1,0) & " (gef. " & Dimension - SubZeile & " Dateien / " & Groesse & ")"
	end if
end if

if Pur then	ZeilenNR = Zeile - 4 else ZeilenNr = Zeile
Kursivzeilen = Kursivzeilen & cstr(SubZeile-1 + ZeilenNr) & ":" & cstr(SubZeile-1 + ZeilenNr) & ","
end sub
'*********************************************************************************************************************
Sub ExifDaten(ByVal Dateiname)
Dim BezA,BezB,BezK

'Kamera und Aufnahmedatum ermitteln - falls Infos vorhanden
Set objOrdnerItem = objOrdner.ParseName(cstr(Dateiname))

on error resume next

Wert = objOrdner.GetDetailsOf(objOrdnerItem, -1)
'Beispiel:	Abmessungen: 2560 x 1920
'		Bild aufgenommen am: 21.05.2006 17:42
'		Kameramodell: DiMAGE A200
'		Typ: JPEG-Bild
'		Gre: 1,20 MB
'oder ab WIN7
BezA = "Abmessungen: "
BezB = "Bild aufgenommen am: "
BezK = "Kameramodell: "
'Besipiel:  Aufnahmedatum: 21.05.2006 17:42
'		Markierungen: Rgen
'		Bewertung: Nicht bewertet
'		Abmessungen: 2560 x 1920
'		Gre: 1,07 MB

PosA = instr(Wert,BezA)			'Abmessung
PosB = instr(Wert,BezB)			'BildDatum
if PosB = 0 then
	BezB = "Aufnahmedatum: "
	PosB =  instr(Wert,BezB)	'BildDatum bei Win7
end if
PosK = instr(Wert,BezK)			'Kamera

if PosA > 0 then
	PosEnde = Instr(PosA, Wert, chr(10))
	VLaenge = len(BezA)
	Abmessung = mid (Wert,PosA + VLaenge, PosEnde - PosA - VLaenge)
else
	Abmessung = "unbekannt"
end if

if PosB > 0 then
	PosEnde = Instr(PosB, Wert, chr(10))
	VLaenge = len(BezB)
	BildDatum = mid (Wert,PosB + VLaenge, PosEnde - PosB - VLaenge)
else
	BildDatum = "unbekannt"
end if

if PosK > 0 then
	PosEnde = Instr(PosK, Wert, chr(10))
	VLaenge = len("Kameramodell: ")
	Kamera = mid (Wert,PosK + VLaenge, PosEnde - PosK - VLaenge)
else
	Kamera = "unbekannt"
end if

Tabelle(Dimension,6) = Kamera
Tabelle(Dimension,7) = BildDatum
Tabelle(Dimension,8) = Abmessung

end sub
'*********************************************************************************************************************
Sub MP3Daten(ByVal Dateiname)
Dim Bezeichnung

'Spieldauer des MP3- bzw. WMA- Files ermitteln - falls Infos vorhanden
Set objOrdnerItem = objOrdner.ParseName(cstr(Dateiname))

on error resume next

Wert = objOrdner.GetDetailsOf(objOrdnerItem, -1)
'Beispiel:	Dauer: 00:05:24 oder ab WIN7
'Beispiel:  Lnge: 00:05:24

Bezeichnung = "Dauer: "
PosA = instr(Wert,Bezeichnung)		'Dauer
if PosA = 0 then
	Bezeichnung = "Lnge: "			'Lnge (ab Win7)
	PosA = instr(Wert,Bezeichnung)
end if
if PosA > 0 then
	PosEnde = Instr(PosA,Wert,chr(10))
	VLaenge = len(Bezeichnung)
	Dauer = mid (Wert,PosA + VLaenge,8)
else
	Dauer = "unbekannt"
end if

Tabelle(Dimension,6) = Dauer

end sub
'*********************************************************************************************************************

Sub Formatierung()
'Formatierung der Excel-Tabelle
With objExcel
    .Rows("1:1").Select
    .Selection.Font.Bold = True
	
    .Columns("A:A").Select
	.Selection.ColumnWidth = 1

if left(Eingabe,1) = "D" then

	.Rows(cstr(Zeile) & ":" & cstr(Zeile)).Select
	.Selection.Font.Bold = True

	.Columns("B:B").Select
	.Selection.ColumnWidth = 3			'Ordnername
	
	.Columns("C:C").Select
		if Exif then
	.Selection.ColumnWidth = 28			'Dateiname
		else
	.Selection.ColumnWidth = 46			'Dateiname	
		end if

	.Columns("F:F").Select
    .Selection.NumberFormat = "#,##0"	'Gre in Byte
	
	.Columns("G:G").Select
	.Selection.NumberFormat = "dd/mm/yyyy hh:mm:ss" 'nder.-Datum
	
	.Columns("I:I").Select
	.Selection.NumberFormat = "dd/mm/yyyy hh:mm:ss" 'Aufn..-Datum
	
	.Columns("K:K").Select
    .Selection.NumberFormat = "#,##0"	'Gre in Byte	
	
	.Columns("D:K").Select
    .Selection.Columns.AutoFit			'Spaltenbreite optimieren
	
	Kursivzeilen = left(Kursivzeilen,len(Kursivzeilen)-1)
	KursivListe = split(Kursivzeilen,",")
	for each Element in Kursivliste
		.Rows(Element).Select
		.Selection.Font.Italic = True
	next

	.Sheets("Tabelle1").Name = "Dateiliste"
else
	.Sheets("Tabelle1").Name = "Ordnerstruktur"
end if

	.Range("A1").Select

'Fuzeile und Format
	if not Pur then
    With .ActiveSheet.PageSetup
		if Exif then .Orientation = 2
        .LeftFooter = "&A"					'A=Register / F=Dateiname
        .PrintTitleRows = "$1:$5"			'Wiederholungszeilen 1 bis 5
        .CenterFooter = ""
        .RightFooter = "von &N Blatt &P"	'von 2 Blatt 1
	end with
	end if
end with

End Sub
'*********************************************************************************************************************

Sub Bereinigung
'bei Pur werden fr eine Musikliste einige Spalten und Zeilen wieder gelscht
With objExcel
	.Columns("B:B").Select
	.Selection.ColumnWidth = 3			'Ordnername

    .Range("A1:A4").Select
    .Selection.EntireRow.Delete
    .Columns("A:A").Select
    .Selection.Delete
    .Columns("C:F").Select
    .Selection.Delete
	
	.Rows("1:1").Select
    .Selection.Font.Bold = True
	
	Kursivzeilen = left(Kursivzeilen,len(Kursivzeilen)-1)
	KursivListe = split(Kursivzeilen,",")
	for each Element in Kursivliste
		.Rows(Element).Select
		.Selection.Font.Italic = True
	next
	
	.Columns("B:C").Select
    .Selection.Columns.AutoFit

	.Sheets("Tabelle1").Name = "Musikliste"
	
	.Range("A1").Select
    .Selection.Font.Italic = False
end with
End Sub
'*********************************************************************************************************************